VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IEncoder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum ENCODER_METRICS
    ENC_M_PCM_PER_DELIVERY_MIN
    ENC_M_PCM_PER_DELIVERY_MAX
    ENC_M_SUPPORT_TAGS
End Enum

Public Enum ENCODER_TAGS
    ENC_TAG_ARTIST = &H1
    ENC_TAG_ALBUM = &H2
    ENC_TAG_TITLE = &H4
    ENC_TAG_YEAR = &H8
    ENC_TAG_GENRE = &H10
    ENC_TAG_TRACK_NUM = &H20
    ENC_TAG_COMMENT = &H40
End Enum

Public Function EncoderInit( _
    ByVal samplerate As Long, _
    ByVal Channels As Integer, _
    ByVal output As String, _
    ByRef tags As StreamTags _
) As SND_RESULT

End Function

Public Property Get Extension( _
) As String

End Property

Public Property Get Description( _
) As String

End Property

Public Function EncoderMetrics( _
    ByVal info As ENCODER_METRICS _
) As Long

End Function

Public Property Get ConfigString( _
) As String

End Property

Public Property Let ConfigString( _
    ByVal strConfig As String _
)

End Property

Public Function Encode( _
    ByVal buffer_ptr As Long, _
    ByVal buffer_len As Long, _
    ByRef buffer_used As Long _
) As SND_RESULT

End Function

Public Function EncoderClose( _
) As SND_RESULT

End Function
