VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "QuickStreamInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements ISoundInfo

Private lngSamplerate       As Long
Private intChannels         As Integer
Private intBitsPerSample    As Integer
Private lngBitrate          As Long
Private lngDurationMS       As Long
Private lngPositionMS       As Long
Private clsTags             As StreamTags

Public Sub SetValues( _
    ByVal samplerate As Long, _
    ByVal Channels As Integer, _
    ByVal BitsPerSample As Integer, _
    ByVal bitrate As Long, _
    ByVal durationMS As Long, _
    ByVal positionMS As Long, _
    tags As StreamTags _
)

    lngSamplerate = samplerate
    intChannels = Channels
    intBitsPerSample = BitsPerSample
    lngBitrate = bitrate
    lngDurationMS = durationMS
    lngPositionMS = positionMS
    Set clsTags = tags
End Sub

Private Property Get ISoundInfo_BitsPerSample( _
) As Integer

    ISoundInfo_BitsPerSample = intBitsPerSample
End Property

Private Property Get ISoundInfo_BitsPerSecond( _
) As Long

    ISoundInfo_BitsPerSecond = lngBitrate
End Property

Private Property Get ISoundInfo_channels( _
) As Integer

    ISoundInfo_channels = intChannels
End Property

Private Property Get ISoundInfo_Duration( _
) As Long

    ISoundInfo_Duration = lngDurationMS
End Property

Private Property Get ISoundInfo_Position( _
) As Long

    ISoundInfo_Position = lngPositionMS
End Property

Private Property Get ISoundInfo_SamplesPerSecond( _
) As Long

    ISoundInfo_SamplesPerSecond = lngSamplerate
End Property

Private Property Get ISoundInfo_Tags( _
) As StreamTags

    Set ISoundInfo_Tags = clsTags
End Property
