VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form frmEqualizer 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "Graphical Equalizer"
   ClientHeight    =   2505
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   6360
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2505
   ScaleWidth      =   6360
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'Fenstermitte
   Begin ComctlLib.Slider sldEQ 
      Height          =   1515
      Index           =   0
      Left            =   975
      TabIndex        =   6
      Top             =   600
      Width           =   525
      _ExtentX        =   926
      _ExtentY        =   2672
      _Version        =   327682
      Orientation     =   1
      Min             =   -12
      Max             =   12
      SelStart        =   -12
      TickStyle       =   2
      Value           =   -12
   End
   Begin prjMonoton.ccXPButton cmdEqOpts 
      Height          =   315
      Left            =   5025
      TabIndex        =   5
      Top             =   75
      Width           =   1215
      _ExtentX        =   2143
      _ExtentY        =   556
      Caption         =   "options"
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin MSComDlg.CommonDialog dlgPreset 
      Left            =   4350
      Top             =   525
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "Equalizer settings (*.eqs)|*.eqs"
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   390
      Left            =   3450
      TabIndex        =   4
      Top             =   3400
      Width           =   1515
   End
   Begin VB.PictureBox picEQ 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   345
      Left            =   1860
      ScaleHeight     =   21
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   179
      TabIndex        =   3
      Top             =   75
      Width           =   2715
   End
   Begin VB.CheckBox chkEnabled 
      Caption         =   "Enabled"
      Height          =   285
      Left            =   180
      TabIndex        =   1
      Top             =   90
      Width           =   1905
   End
   Begin ComctlLib.Slider sldPreamp 
      Height          =   1515
      Left            =   150
      TabIndex        =   7
      Top             =   600
      Width           =   525
      _ExtentX        =   926
      _ExtentY        =   2672
      _Version        =   327682
      Orientation     =   1
      Min             =   -12
      Max             =   12
      SelStart        =   -12
      TickStyle       =   2
      Value           =   -12
   End
   Begin VB.Label lblPreamp 
      Caption         =   "Preamp"
      Height          =   285
      Left            =   150
      TabIndex        =   2
      Top             =   2130
      Width           =   555
   End
   Begin VB.Label lblEQID 
      Alignment       =   2  'Zentriert
      AutoSize        =   -1  'True
      Height          =   195
      Index           =   0
      Left            =   1200
      TabIndex        =   0
      Top             =   2100
      Width           =   75
   End
   Begin VB.Menu mnuOpts 
      Caption         =   "Options"
      Visible         =   0   'False
      Begin VB.Menu mnuReset 
         Caption         =   "Reset"
      End
      Begin VB.Menu mnuSaveSettings 
         Caption         =   "Save settings"
      End
      Begin VB.Menu mnuLoadSetting 
         Caption         =   "Load setting"
      End
   End
End
Attribute VB_Name = "frmEqualizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type POINT
    x                       As Double
    y                       As Double
End Type

Private Type vbcolor
    red                     As Single
    green                   As Single
    blue                    As Single
End Type

Private Const Pi            As Double = 3.14159265358979

Private Const F             As Long = 5
Private Const POINTS        As Long = 10

Private Const COLOR_1       As Long = &H122BC
Private Const COLOR_2       As Long = &H22A8E1
Private Const COLOR_3       As Long = &HCC00

Private p(1 To EQU_BANDS)   As POINT

Public Sub Update()
    Form_Load
End Sub

Private Sub chkEnabled_Click()
    Dim i   As Long

    For i = 0 To EQU_BANDS - 1
        clsEQUBands(i).Enabled = chkEnabled.Value = 1
    Next

    settingEQUEnabled = chkEnabled.Value = 1
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub Form_Unload( _
    Cancel As Integer _
)

    SaveEQS AddSlash(App.path) & "geq.eqs"
End Sub

Private Sub mnuLoadSetting_Click()
    Dim i   As Integer

    With dlgPreset
        .FileName = vbNullString
        .flags = cdlOFNFileMustExist Or cdlOFNExplorer
        .ShowOpen
        If .FileName = vbNullString Then Exit Sub
    End With

    If Not LoadEQS(dlgPreset.FileName) Then
        MsgBox "Could not load settings file!", vbExclamation, APPNAME
    End If

    For i = 0 To sldEQ.UBound
        sldEQ_Scroll i
    Next
    sldPreamp_Scroll

    DrawEQ
End Sub

Private Sub mnuReset_Click()
    Dim i   As Integer

    For i = 0 To EQU_BANDS - 1
        sldEQ(i).Value = 0
        sldEQ_Scroll i
    Next
    sldPreamp.Value = 0
    sldPreamp_Scroll
End Sub

Private Sub cmdEqOpts_Click()
    PopupMenu mnuOpts, , cmdEqOpts.Left, cmdEqOpts.Top + cmdEqOpts.Height
End Sub

Private Sub Form_Load()
    Dim i               As Long
    Static eqsloaded    As Boolean

    ' create equalizer sliders
    If sldEQ.UBound = 0 Then
        For i = 1 To EQU_BANDS - 1
            Load sldEQ(i)

            With sldEQ(i)
                .Left = sldEQ(i - 1).Left + .Width + (20 * Screen.TwipsPerPixelX)
                .Visible = True
            End With

            Load lblEQID(i)

            With lblEQID(i)
                .Left = sldEQ(i).Left + (15 * Screen.TwipsPerPixelX)
                .Visible = True
            End With
        Next
    End If

    chkEnabled.Value = Abs(CInt(settingEQUEnabled))

    sldPreamp.Value = -settingPreamp

    ' get values (frequency, gain) for each band slider
    For i = 0 To EQU_BANDS - 1
        sldEQ(i).Value = -clsEQUBands(i).GainDB

        If clsEQUBands(i).Frequency > 1000 Then
            lblEQID(i).Caption = Fix(clsEQUBands(i).Frequency / 1000) & " kHz"
        Else
            lblEQID(i).Caption = Fix(clsEQUBands(i).Frequency) & " Hz"
        End If
    Next

    Me.Width = lblEQID(EQU_BANDS - 1).Left + lblEQID(EQU_BANDS - 1).Width + lblPreamp.Left * 2
    cmdEqOpts.Left = Me.ScaleWidth - cmdEqOpts.Width - (10 * Screen.TwipsPerPixelX)
    picEQ.Left = Me.ScaleWidth / 2 - (picEQ.Width / 2)

    If Not eqsloaded Then
        LoadEQS AddSlash(App.path) & "geq.eqs"

        For i = 0 To sldEQ.UBound
            sldEQ_Scroll CInt(i)
        Next
        sldPreamp_Scroll

        eqsloaded = True
    End If

    DrawEQ
End Sub

Private Sub DrawEQ()
    Dim x       As Long
    Dim y       As Long
    Dim i       As Long
    Dim drwh    As Long
    Dim drww    As Long
    Dim drws    As Long
    Dim pah     As Long

    With picEQ
        .AutoRedraw = True
        .Cls
        .ScaleMode = 3

        drwh = .ScaleHeight
        drww = .ScaleWidth

        .BackColor = &H2C1F18
    End With

    ' space between 2 points
    drws = (drww - 10) / EQU_BANDS

    ' eq band points
    For i = 1 To EQU_BANDS
        p(i).x = drws * i - 4
        p(i).y = (sldEQ(i - 1).Value / sldEQ(0).Max) * (drwh / 2) + (drwh / 2)
    Next

    picEQ.Cls

    ' Slider
    picEQ.ForeColor = &H42585E

    For i = 1 To EQU_BANDS
        picEQ.Line (p(i).x, 2)-(p(i).x, drwh - 2)
    Next

    ' draw preamp level
    picEQ.ForeColor = &H839EA7
    pah = (-sldPreamp.Value / sldPreamp.Max) * (drwh / 2) + (drwh / 2) - 0.5
    picEQ.Line (0, pah)-(drww, pah)

    ' draw a smoothed line with cosine interpolation
    i = 1
    x = 0

    y = CosineInterpolate(p(1).y, p(2).y, (x / F) / drws)
    picEQ.PSet (p(1).x, y)

    For i = 1 To EQU_BANDS - 1
        For x = 0 To drws * F
            y = CosineInterpolate(p(i).y, p(i + 1).y, (x / F) / drws) - 0.5
            picEQ.ForeColor = GetGradColor(drwh, y, COLOR_1, COLOR_2, COLOR_3)
            picEQ.Line -(p(i).x + (x / F), y)
        Next
    Next
End Sub

Private Function GetGradColor( _
    ByVal Max As Single, _
    ByVal Value As Single, _
    ByVal colstart As Long, _
    ByVal colmiddle As Long, _
    ByVal colend As Long _
) As Long

    ' get the color of a level in a gradient

    Dim udtCol1 As vbcolor
    Dim udtCol2 As vbcolor
    Dim udtCol3 As vbcolor
    Dim udtColS As vbcolor
    Dim udtColE As vbcolor
    Dim udtDrw  As vbcolor

    udtCol1 = translate_color(colstart)
    udtCol2 = translate_color(colmiddle)
    udtCol3 = translate_color(colend)

    If Value < Max / 2 Then
        udtDrw = udtCol1
        udtColS = udtCol1
        udtColE = udtCol2
    Else
        Value = Value - (Max / 2)
        udtDrw = udtCol2
        udtColS = udtCol2
        udtColE = udtCol3
    End If

    Max = Max / 2

    With udtDrw
        .red = .red + (((udtColE.red - udtColS.red) / Max) * Value)
        .green = .green + (((udtColE.green - udtColS.green) / Max) * Value)
        .blue = .blue + (((udtColE.blue - udtColS.blue) / Max) * Value)

        GetGradColor = RGB(.red, .green, .blue)
    End With
End Function

Private Function translate_color( _
    ByVal olecol As Long _
) As vbcolor

    With translate_color
        .blue = (olecol \ &H10000) And &HFF
        .green = (olecol \ &H100) And &HFF
        .red = olecol And &HFF
    End With
End Function

' http://astronomy.swin.edu.au/~pbourke/other/interpolation/index.html
Private Function CosineInterpolate( _
    ByVal Y1 As Double, _
    ByVal Y2 As Double, _
    ByVal mu As Double _
) As Double

    Dim mu2 As Double

    mu2 = (1 - Cos(mu * Pi)) / 2
    CosineInterpolate = (Y1 * (1 - mu2) + Y2 * mu2)
End Function

Private Sub mnuSaveSettings_Click()
    With dlgPreset
        .FileName = vbNullString
        .flags = cdlOFNOverwritePrompt Or cdlOFNExplorer
        .ShowSave
        If .FileName = vbNullString Then Exit Sub
    End With

    If Not SaveEQS(dlgPreset.FileName) Then
        MsgBox "Couldn't save the settings file!", vbExclamation, APPNAME
    End If
End Sub

Private Sub sldEQ_Click( _
    Index As Integer _
)

    sldEQ_Scroll Index
End Sub

Private Sub sldEQ_MouseUp( _
    Index As Integer, _
    Button As Integer, _
    Shift As Integer, _
    x As Single, _
    y As Single _
)

    If Button = 2 Then
        sldEQ(Index).Value = 0
        sldEQ_Scroll Index
    End If
End Sub

Private Sub sldEQ_Scroll( _
    Index As Integer _
)

    clsEQUBands(Index).GainDB = -sldEQ(Index).Value
    DrawEQ
End Sub

Private Sub sldPreamp_Click()
    sldPreamp_Scroll
End Sub

Private Sub sldPreamp_MouseUp( _
    Button As Integer, _
    Shift As Integer, _
    x As Single, _
    y As Single _
)

    If Button = 2 Then
        sldPreamp.Value = 0
        sldPreamp_Scroll
    End If
End Sub

Private Sub sldPreamp_Scroll()
    settingPreamp = -sldPreamp.Value
    DrawEQ
End Sub

Private Function SaveEQS( _
    ByVal strFile As String _
) As Boolean

    On Error GoTo ErrorHandler

    Dim fh  As Integer: fh = FreeFile()
    Dim i   As Long

    Open strFile For Binary As #fh
        Put #fh, , CStr("MONOEQF")
        Put #fh, , CLng(sldPreamp.Value)
        For i = 0 To EQU_BANDS - 1
            Put #fh, , CLng(sldEQ(i).Value)
        Next
    Close #fh

    SaveEQS = True

ErrorHandler:
End Function

Public Function LoadEQS( _
    ByVal strFile As String _
) As Boolean

    On Error GoTo ErrorHandler

    Dim fh      As Integer: fh = FreeFile()
    Dim i       As Long
    Dim strHdr  As String
    Dim lngVal  As Long

    strHdr = Space(Len("MONOEQF"))

    Open strFile For Binary As #fh
        Get #fh, , strHdr
        If strHdr = "MONOEQF" Then
            Get #fh, , lngVal
            sldPreamp.Value = lngVal

            For i = 0 To EQU_BANDS - 1
                Get #fh, , lngVal
                sldEQ(i).Value = lngVal
            Next

            LoadEQS = True
        End If
    Close #fh

ErrorHandler:
End Function

