VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EncoderCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public EncoderMP3   As EncoderMP3
Public EncoderWAV   As EncoderWAV
Public EncoderWMA   As EncoderWMA
Public EncoderAPE   As EncoderAPE
Public EncoderOGG   As EncoderOGG

Public Sub ShowSettingsDialog( _
    Optional owner As Form _
)

    frmEncSettings.LoadMe Me, owner

    settingEncCfgMP3 = AsIEncoder(EncoderMP3).ConfigString
    settingEncCfgWAV = AsIEncoder(EncoderWAV).ConfigString
    settingEncCfgWMA = AsIEncoder(EncoderWMA).ConfigString
    settingEncCfgAPE = AsIEncoder(EncoderAPE).ConfigString
    settingEncCfgOGG = AsIEncoder(EncoderOGG).ConfigString
End Sub

Private Sub Class_Initialize()
    Set EncoderMP3 = New EncoderMP3
    Set EncoderWAV = New EncoderWAV
    Set EncoderWMA = New EncoderWMA
    Set EncoderAPE = New EncoderAPE
    Set EncoderOGG = New EncoderOGG

    AsIEncoder(EncoderMP3).ConfigString = settingEncCfgMP3
    AsIEncoder(EncoderWAV).ConfigString = settingEncCfgWAV
    AsIEncoder(EncoderWMA).ConfigString = settingEncCfgWMA
    AsIEncoder(EncoderAPE).ConfigString = settingEncCfgAPE
    AsIEncoder(EncoderOGG).ConfigString = settingEncCfgOGG
End Sub

Private Function AsIEncoder( _
    iobj As IEncoder _
) As IEncoder

    Set AsIEncoder = iobj
End Function

Private Sub Class_Terminate()
    settingEncCfgMP3 = AsIEncoder(EncoderMP3).ConfigString
    settingEncCfgWAV = AsIEncoder(EncoderWAV).ConfigString
    settingEncCfgWMA = AsIEncoder(EncoderWMA).ConfigString
    settingEncCfgAPE = AsIEncoder(EncoderAPE).ConfigString
    settingEncCfgOGG = AsIEncoder(EncoderOGG).ConfigString
End Sub
