VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PlaylistWriter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private clsWriters()    As IPlaylistWriter
Private clsWriter       As IPlaylistWriter
Private lngWriterCnt    As Long

Private Sub AddWriter( _
    Writer As IPlaylistWriter _
)

    ReDim Preserve clsWriters(lngWriterCnt) As IPlaylistWriter
    Set clsWriters(lngWriterCnt) = Writer
    lngWriterCnt = lngWriterCnt + 1
End Sub

Private Sub Class_Initialize()
    AddWriter New PlaylistWriterM3U
    AddWriter New PlaylistWriterPLS
End Sub

Public Property Get WriterCount( _
) As Long

    WriterCount = lngWriterCnt
End Property

Public Property Get WriterExtension( _
    ByVal Index As Long _
) As String

    WriterExtension = clsWriters(Index).Extension
End Property

Public Function SelectWriter( _
    ByVal Index As Long _
) As Boolean

    If Index < 0 Or Index > (lngWriterCnt - 1) Then
        Exit Function
    End If

    Set clsWriter = clsWriters(Index)

    SelectWriter = True
End Function

Public Sub ClearList()
    clsWriter.ClearList
End Sub

Public Sub AddFile( _
    ByVal file As String, _
    ByVal title As String, _
    ByVal Length As Long _
)

    clsWriter.AddFile file, title, Length
End Sub

Public Function SaveList( _
    ByVal file As String _
) As Boolean

    SaveList = clsWriter.SaveList(file)
End Function
