VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PlaylistWriterM3U"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IPlaylistWriter

Private Const Extension     As String = "m3u"

Private colFiles            As Collection

Private Sub Class_Initialize()
    IPlaylistWriter_ClearList
End Sub

Private Sub IPlaylistWriter_AddFile( _
    ByVal file As String, _
    ByVal title As String, _
    ByVal length As Long _
)

    If file = "" Then Exit Sub

    If title = "" Then
        title = GetFilename(file)
    End If

    colFiles.Add file & Chr$(0) & Chr$(1) & _
                 title & Chr$(0) & Chr$(1) & _
                 length
End Sub

Private Sub IPlaylistWriter_ClearList()
    Set colFiles = New Collection
End Sub

Private Property Get IPlaylistWriter_Extension( _
) As String

    IPlaylistWriter_Extension = Extension
End Property

Private Function IPlaylistWriter_SaveList( _
    ByVal file As String _
) As Boolean

    On Error GoTo OnError

    Dim fh          As Integer: fh = FreeFile()
    Dim strParts()  As String
    Dim strFileName As String
    Dim strTitle    As String
    Dim lngLength   As Long
    Dim i           As Long

    Open file For Output As #fh
        Print #fh, "#EXTM3U"

        For i = 1 To colFiles.count
            strParts = Split(colFiles.item(i), Chr$(0) & Chr$(1))
            strFileName = strParts(0)
            strTitle = strParts(1)
            lngLength = CLng(strParts(2))

            Print #fh, "#EXTINF:" & lngLength & "," & strTitle
            Print #fh, strFileName
        Next
    Close #fh

    IPlaylistWriter_SaveList = True

OnError:
    Close #fh
End Function
